#!/bin/bash

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin

#************************************************
# target
#************************************************
# Cent OS 5.x
# ClamAV
# MySQL 5.0.x
# Postgres
# Apache 2.2.3
# PHP 5.1.6
# vsftp
# qmail

#************************************************
# vars
#************************************************

# server
#   architecture ( x86_64 / i386 )
SERVER_ARCH='x86_64'
#   hostname
SERVER_HOSTNAME='www.example.com'
#   ip
SERVER_IP='999.999.999.999'
#   mail
SERVER_EMAIL_ROOT='root@example.com'

# useradd
FILE_USERADD='useradd.txt'

# yum
#   rpmforge (check latest : http://packages.sw.be/rpmforge-release/ )
FILE_RPM_FORGE="rpmforge-release-0.5.2-2.el5.rf.${SERVER_ARCH}.rpm"

# iptables
FILE_IPTABLES_CONF='iptables.sh'

# Clam AntiVirus
FILE_CLAMD_CONF='clamd.conf'
FILE_FRESHCLAM_CONF='freshclam.conf'

# ntpd
FILE_NTPD_CONF='ntp.conf'

# mysql
FILE_MYSQL_CONF='my.cnf'
MYSQL_PASSWORD_ROOT='hogehoge'

# postgresql
POSTGRESQL_NAME='postgresql-9.0'
#   postgresql* (check latest : http://www.pgrpms.org/packages.php )
FILE_POSTGRESQL="postgresql90-9.0.4-1PGDG.rhel5.${SERVER_ARCH}.rpm"
FILE_POSTGRESQL_LIBS="postgresql90-libs-9.0.4-1PGDG.rhel5.${SERVER_ARCH}.rpm"
FILE_POSTGRESQL_SERVER="postgresql90-server-9.0.4-1PGDG.rhel5.${SERVER_ARCH}.rpm"

# httpd 
FILE_HTTPD_CONF='httpd.conf'

# php
FILE_PHP_CONF='php.ini'

# vsftpd
FILE_VSFTPD_CONF='vsftpd.conf'

# qmail
#   qmail (check latest : http://cr.yp.to/qmail.html )
FILE_QMAIL='qmail-1.03.tar.gz'
#   qmail-date-localtime (check latest : http://www.google.com/search?q=qmail-date-localtime )
FILE_QMAIL_DATE_LOCALTIME='qmail-date-localtime.patch'
#   qmail-smtpd-auth (check latest : http://tomclegg.net/qmail/#qmail-smtpd-auth )
FILE_QMAIL_SMTPD_AUTH='qmail-smtpd-auth-0.31.tar.gz'
#   qmail-smtpd-relay-reject (check latest : http://qmail.mirrors.summersault.com/ )
FILE_QMAIL_SMTPD_RELAY_REJECT='qmail-smtpd-relay-reject'
#   checkpassword (check latest : http://cr.yp.to/checkpwd/install.html )
FILE_CHECKPASSWORD='checkpassword-0.90.tar.gz'
#   ucspi-tcp (check latest : http://cr.yp.to/ucspi-tcp/install.html )
FILE_UCSPITCP='ucspi-tcp-0.88.tar.gz'
#   fastforward (check latest : http://cr.yp.to/fastforward.html )
FILE_FASTFORWARD='fastforward-0.51.tar.gz'
#   vpopmail (check latest : http://sourceforge.net/project/showfiles.php?group_id=85937&package_id=89104)
FILE_VPOPMAIL='vpopmail-5.4.32.tar.gz'
#   qmail-control-script
FILE_QMAIL_CONT='qmail'

echo '#************************************************'
echo '# [start] uninstall'
echo ''

yum -y remove yum-updatesd
yum -y remove yum-utils yum-downloadonly yum-downloadonly
yum -y remove clamd
yum -y remove ntp
yum -y remove httpd
yum -y remove php php-mbstring php-gd php-mysql
yum -y remove vsftpd
yum -y remove mysql-server

echo ''
echo '# [finish] uninstall'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] useradd'
echo ''

if [ -s ${FILE_USERADD} ];
then
	while read LINE
	do
		LIST_PARAM=(${LINE})
		useradd -d ${LIST_PARAM[1]} -m ${LIST_PARAM[0]}
		echo "${LIST_PARAM[0]}:${LIST_PARAM[2]}" | chpasswd
	done < ${FILE_USERADD}
else
	echo "[error] not exist ${FILE_USERADD}"
fi

echo ''
echo '# [finish] useradd'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] aliases'
echo ''

mv /etc/aliases /etc/aliases.orgn
sed -e "s/^#root:/root:/" /etc/aliases.orgn > /etc/aliases.tmp
sed -e "s/^root:.*/root: ${SERVER_EMAIL_ROOT}/" /etc/aliases.tmp > /etc/aliases
rm -f /etc/aliases.tmp
newaliases
echo 'this is test mail from aliases setting section'|mail root

echo '[info] /etc/aliases'
cat /etc/aliases

echo ''
echo '# [finish] aliases'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] hostname'
echo ''

hostname ${SERVER_HOSTNAME}
mv /etc/sysconfig/network /etc/sysconfig/network.orgn
sed -e "s/^HOSTNAME=.*/HOSTNAME=${SERVER_HOSTNAME}/" /etc/sysconfig/network.orgn > /etc/sysconfig/network

echo '[info] /etc/sysconfig/network'
cat /etc/sysconfig/network

echo ''
echo '# [finish] hostname'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] yum'
echo ''

# setup
yum -y install yum-utils yum-fastestmirror yum-downloadonly yum-downloadonly
yum -y update

# start
/etc/rc.d/init.d/yum-cron start
chkconfig yum-cron on

# info
echo '[info] yum-cron deamon'
chkconfig --list yum-cron


# setup
yum -y install yum-priorities
cp -f /etc/yum.repos.d/CentOS-Base.repo /etc/yum.repos.d/CentOS-Base.repo.orgn
mv -f /etc/yum.repos.d/CentOS-Base.repo /etc/yum.repos.d/CentOS-Base.repo.tmp
sed -e '/^\[base\]/a \
priority=1' /etc/yum.repos.d/CentOS-Base.repo.tmp > /etc/yum.repos.d/CentOS-Base.repo
mv -f /etc/yum.repos.d/CentOS-Base.repo /etc/yum.repos.d/CentOS-Base.repo.tmp
sed -e '/^\[updates\]/a \
priority=1' /etc/yum.repos.d/CentOS-Base.repo.tmp > /etc/yum.repos.d/CentOS-Base.repo
mv -f /etc/yum.repos.d/CentOS-Base.repo /etc/yum.repos.d/CentOS-Base.repo.tmp
sed -e '/^\[addons\]/a \
priority=1' /etc/yum.repos.d/CentOS-Base.repo.tmp > /etc/yum.repos.d/CentOS-Base.repo
mv -f /etc/yum.repos.d/CentOS-Base.repo /etc/yum.repos.d/CentOS-Base.repo.tmp
sed -e '/^\[extras\]/a \
priority=1' /etc/yum.repos.d/CentOS-Base.repo.tmp > /etc/yum.repos.d/CentOS-Base.repo
rm -f /etc/yum.repos.d/CentOS-Base.repo.tmp

rpm --import http://apt.sw.be/RPM-GPG-KEY.dag.txt
rpm -ivh ${FILE_RPM_FORGE}

# info
echo '[info] /etc/yum.repos.d/CentOS-Base.repo'
cat /etc/yum.repos.d/CentOS-Base.repo

echo ''
echo '# [finish] yum'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] SELinux'
echo ''

setenforce 0
mv /etc/sysconfig/selinux /etc/sysconfig/selinux.orgn
sed -e 's/^SELINUX=[a-z]*/SELINUX=disabled/' /etc/sysconfig/selinux.orgn > /etc/sysconfig/selinux

echo ''
echo '# [finish] SELinux'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] iptables'
echo ''

if [ -s ${FILE_IPTABLES_CONF} ];
then
	# setup
	cp ${FILE_IPTABLES_CONF} /root/${FILE_IPTABLES_CONF}
	chmod 700 /root/${FILE_IPTABLES_CONF}
	/root/${FILE_IPTABLES_CONF}
	
	# start
	/etc/rc.d/init.d/iptables start
	chkconfig iptables on
	
	# info
	echo '[info] iptables deamon'
	chkconfig --list iptables
else
	echo "[error] not exist ${FILE_IPTABLES_CONF}"
fi

echo ''
echo '# [finish] iptables'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] ntpd'
echo ''

# setup
yum -y install ntp
mv /etc/ntp.conf /etc/ntp.conf.orgn
if [ -s ${FILE_NTPD_CONF} ];
then
	cp ${FILE_NTPD_CONF} /etc/ntp.conf
else
	echo "[error] not exist ${FILE_NTPD_CONF}"
	cp /etc/ntp.conf.orgn /etc/ntp.conf
fi

# adjust
ntpdate ntp.nict.jp

# start
/etc/rc.d/init.d/ntpd start
chkconfig ntpd on

# info
echo '[info] ntpd deamon'
chkconfig --list ntpd
echo '[info] ntpd status'
ntpq -p

echo ''
echo '# [finish] ntpd'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] Clam AntiVirus'
echo ''

# setup
yum -y install clamd
mv /etc/clamd.conf /etc/clamd.conf.orgn
if [ -s ${FILE_CLAMD_CONF} ];
then
	cp ${FILE_CLAMD_CONF} /etc/clamd.conf
else
	echo "[error] not exist ${FILE_CLAMD_CONF}"
	cp /etc/clamd.conf.orgn /etc/clamd.conf
fi
mv /etc/freshclam.conf /etc/freshclam.conf.orgn
if [ -s ${FILE_FRESHCLAM_CONF} ];
then
	cp ${FILE_FRESHCLAM_CONF} /etc/freshclam.conf
else
	echo "[error] not exist ${FILE_FRESHCLAM_CONF}"
	cp /etc/freshclam.conf.orgn /etc/freshclam.conf
fi
freshclam

# start
/etc/rc.d/init.d/clamd start
chkconfig clamd on

# info
echo '[info] clamd deamon'
chkconfig --list clamd

echo ''
echo '# [finish] Clam AntiVirus'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] mysql'
echo ''

# setup
yum -y install mysql-server
mv /etc/my.cnf /etc/my.cnf.orgn
if [ -s ${FILE_MYSQL_CONF} ];
then
	cp ${FILE_MYSQL_CONF} /etc/my.cnf
else
	echo "[error] not exist ${FILE_MYSQL_CONF}"
	cp /etc/my.cnf.orgn /etc/my.cnf
fi

# start
/etc/rc.d/init.d/mysqld start
chkconfig mysqld on

# info
echo '[info] mysqld deamon'
chkconfig --list mysqld

echo ''
echo '# [finish] mysql'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] postgresql'
echo ''

# setup
rpm -ivh ${FILE_POSTGRESQL_LIBS}
rpm -ivh ${FILE_POSTGRESQL}
rpm -ivh ${FILE_POSTGRESQL_SERVER}

# external
if [ -s ${FILE_POSTGRESQL_EXT} ];
then
	echo "[start external] ${FILE_POSTGRESQL_EXT}"
	chmod +x ${FILE_POSTGRESQL_EXT}
	./${FILE_POSTGRESQL_EXT}
	echo "[finish external] ${FILE_POSTGRESQL_EXT}"
fi

# initialize database
/etc/rc.d/init.d/${POSTGRESQL_NAME} initdb

# start
/etc/rc.d/init.d/${POSTGRESQL_NAME} start
chkconfig ${POSTGRESQL_NAME} on

# info
echo '[info] postgresql deamon'
chkconfig --list ${POSTGRESQL_NAME}

echo ''
echo '# [finish] postgresql'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] httpd'
echo ''

# setup
yum -y install httpd
mv /etc/httpd/conf/httpd.conf /etc/httpd/conf/httpd.conf.orgn
if [ -s ${FILE_HTTPD_CONF} ];
then
	cp ${FILE_HTTPD_CONF} /etc/httpd/conf/httpd.conf
	mv -f /etc/httpd/conf/httpd.conf /etc/httpd/conf/httpd.conf.tmp
	sed -e "s/SERVER_HOSTNAME/${SERVER_HOSTNAME}/" /etc/httpd/conf/httpd.conf.tmp > /etc/httpd/conf/httpd.conf
	mv -f /etc/httpd/conf/httpd.conf /etc/httpd/conf/httpd.conf.tmp
	sed -e "s/SERVER_IP/${SERVER_IP}/" /etc/httpd/conf/httpd.conf.tmp > /etc/httpd/conf/httpd.conf
	mv -f /etc/httpd/conf/httpd.conf /etc/httpd/conf/httpd.conf.tmp
	sed -e "s/SERVER_EMAIL_ROOT/${SERVER_EMAIL_ROOT}/" /etc/httpd/conf/httpd.conf.tmp > /etc/httpd/conf/httpd.conf
	rm -f /etc/httpd/conf/httpd.conf.tmp
else
	echo "[error] not exist ${FILE_HTTPD_CONF}"
	cp /etc/httpd/conf/httpd.conf.orgn /etc/httpd/conf/httpd.conf
fi

# default web page
chown root:root /home/www
chmod 755 /home/www
mkdir /home/www/logs
touch /home/www/logs/log_access
touch /home/www/logs/log_error
mkdir /home/www/_skel
mkdir /home/www/_skel/logs
mkdir /home/www/_skel/public_html
mkdir /home/www/_skel/user_lib
touch /home/www/_skel/logs/log_access
touch /home/www/_skel/logs/log_error
cp -Rp /home/www/_skel /home/www/${SERVER_HOSTNAME}

# start
/etc/rc.d/init.d/httpd start
chkconfig httpd on

# info
echo '[info] httpd deamon'
chkconfig --list httpd

echo ''
echo '# [finish] httpd'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] php'
echo ''

# setup
yum -y install php php-mbstring php-gd php-mysql
mv /etc/php.ini /etc/php.ini.orgn
if [ -s ${FILE_PHP_CONF} ];
then
	cp ${FILE_PHP_CONF} /etc/php.ini
else
	echo "[error] not exist ${FILE_PHP_CONF}"
	cp /etc/php.ini.orgn /etc/php.ini
fi

# start
/etc/rc.d/init.d/httpd restart

echo ''
echo '# [finish] php'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] vsftpd'
echo ''

# setup
yum -y install vsftpd
mv /etc/vsftpd/vsftpd.conf /etc/vsftpd/vsftpd.conf.orgn
if [ -s ${FILE_VSFTPD_CONF} ];
then
	cp ${FILE_VSFTPD_CONF} /etc/vsftpd/vsftpd.conf
else
	echo "[error] not exist ${FILE_VSFTPD_CONF}"
	cp /etc/vsftpd/vsftpd.conf.orgn /etc/vsftpd/vsftpd.conf
fi

# start
/etc/rc.d/init.d/vsftpd start
chkconfig vsftpd on

# info
echo '[info] vsftpd deamon'
chkconfig --list vsftpd

echo ''
echo '# [finish] vsftpd'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] qmail'
echo ''

mkdir /var/qmail
groupadd nofiles
useradd -g nofiles -s /sbin/nologin alias -m -d /var/qmail/alias -k /dev/null
useradd -g nofiles -d /var/qmail -s /sbin/nologin -M qmaild
useradd -g nofiles -d /var/qmail -s /sbin/nologin -M qmaill
useradd -g nofiles -d /var/qmail -s /sbin/nologin -M qmailp
groupadd qmail
useradd -g qmail -d /var/qmail -s /sbin/nologin -M qmailq
useradd -g qmail -d /var/qmail -s /sbin/nologin -M qmailr
useradd -g qmail -d /var/qmail -s /sbin/nologin -M qmails
tar zxvf ${FILE_QMAIL}
tar zxvf ${FILE_QMAIL_SMTPD_AUTH}
cd `basename ${FILE_QMAIL} .tar.gz`
mv -f ../`basename ${FILE_QMAIL_SMTPD_AUTH} .tar.gz`/* .
mv -f ../${FILE_QMAIL_DATE_LOCALTIME} .
mv -f ../${FILE_QMAIL_SMTPD_RELAY_REJECT} .
patch < ${FILE_QMAIL_DATE_LOCALTIME}
patch < auth.patch
patch < ${FILE_QMAIL_SMTPD_RELAY_REJECT}
sed -i 's/^extern int errno;/#include<errno.h>/' error.h
make setup check
./config-fast `hostname`
echo `hostname` >> /var/qmail/control/me
echo `hostname` >> /var/qmail/control/rcpthosts
echo `hostname` >> /var/qmail/control/locals
echo "10485760" > /var/qmail/control/databytes
touch /var/qmail/control/doublebounceto
cd ..
echo 'MANPATH /var/qmail/man' >> /etc/man.config

# checkpassword
tar zxvf ${FILE_CHECKPASSWORD}
cd `basename ${FILE_CHECKPASSWORD} .tar.gz`
sed -i 's/^extern int errno;/#include<errno.h>/' error.h
make && make setup check
cd ..
chown root:nofiles /bin/checkpassword
chmod 4750 /bin/checkpassword

# tcpserver
tar zxvf ${FILE_UCSPITCP}
cd `basename ${FILE_UCSPITCP} .tar.gz`
sed -i 's/^extern int errno;/#include<errno.h>/' error.h
make setup check
cd ..
echo '127.:allow,RELAYCLIENT=""' > /etc/tcp.smtp
tcprules /etc/tcp.smtp.cdb /etc/tcp.smtp.tmp < /etc/tcp.smtp

# fastforward
tar zxvf ${FILE_FASTFORWARD}
cd `basename ${FILE_FASTFORWARD} .tar.gz`
sed -i 's/^extern int errno;/#include<errno.h>/' error.h
make setup check
cd ..
chmod 0 /usr/bin/newaliases
mv /usr/bin/newaliases /usr/bin/newaliases.bak
ln -s /var/qmail/bin/newaliases /usr/bin/newaliases
newaliases
ll /etc/aliases.cdb
echo "|/var/qmail/bin/fastforward -p -d /etc/aliases.cdb" > /var/qmail/alias/.qmail-default

# vpopmail
groupmod -g 20001 postfix
usermod -u 20001 -g 20001 postfix
groupadd -g 89 vchkpw
useradd -g vchkpw -u 89 vpopmail -s /sbin/nologin -m -k /dev/null
tar zxvf ${FILE_VPOPMAIL}
cd `basename ${FILE_VPOPMAIL} .tar.gz`
./configure --enable-roaming-users=y --enable-clear-passwd=n
make && make install-strip
cd ..
cp /etc/tcp.* /home/vpopmail/etc/
sed -i 's/^#default_quota.*/default_quota 10485760/' /home/vpopmail/etc/vlimits.default
echo `hostname -d` > /home/vpopmail/etc/defaultdomain

/etc/rc.d/init.d/sendmail stop
chkconfig sendmail off
chkconfig --list sendmail
chmod 0 /usr/lib/sendmail
chmod 0 /usr/sbin/sendmail
mv /usr/lib/sendmail /usr/lib/sendmail.bak
mv /usr/sbin/sendmail /usr/sbin/sendmail.bak
ln -s /var/qmail/bin/sendmail /usr/lib/sendmail
ln -s /var/qmail/bin/sendmail /usr/sbin/sendmail
cp /var/qmail/boot/home /var/qmail/rc
sed -i 's/Mailbox/Maildir\//g' /var/qmail/rc

if [ -s ${FILE_QMAIL_CONT} ];
then
	cp ${FILE_QMAIL_CONT} /etc/rc.d/init.d/qmail
	chmod +x /etc/rc.d/init.d/qmail
	/etc/rc.d/init.d/qmail start
	chkconfig qmail --add
	chkconfig qmail on
	echo '[info] qmail deamon'
	chkconfig --list qmail
else
	echo "[error] not exist ${FILE_QMAIL_CONT}"
fi

echo 'this is test mail from qmail setting section'|mail root

echo ''
echo '# [finish] qmail'
echo '#************************************************'
echo ''
echo '#************************************************'
echo '# [start] other'
echo ''

# mysql
sed -e "s/MYSQL_PASSWORD_ROOT/${MYSQL_PASSWORD_ROOT}/" mysql.sql > mysql.sql.gen
mysql -u root < mysql.sql.gen

# vsftp
echo '' > /etc/vsftpd/user_list

# cron
# daily backup
sed -e "s/MYSQL_PASSWORD_ROOT/${MYSQL_PASSWORD_ROOT}/" backup.sh > /etc/cron.daily/backup.sh
chmod 700 /etc/cron.daily/backup.sh
# daily scan
cp clamscan /etc/cron.daily/
chmod 700 /etc/cron.daily/clamscan
# monthly logrotate
cp log_apache.sh /etc/cron.monthly/
chmod 700 /etc/cron.monthly/log_apache.sh
# monthly dump every site
sed -e "s/MYSQL_PASSWORD_ROOT/${MYSQL_PASSWORD_ROOT}/" dump_mysql.sh > /etc/cron.daily/dump_mysql.sh
chmod 700 /etc/cron.monthly/dump_mysql.sh

# cleanup yum
yum-complete-transaction -y

echo ''
echo '# [finish] other'
echo '#************************************************'
