#!/bin/sh

#************************************************
# Universal Reset
#************************************************
iptables -F

#************************************************
# Policy Set
#************************************************
iptables -P INPUT DROP
iptables -P OUTPUT ACCEPT
iptables -P FORWARD DROP

#************************************************
# localhost
#************************************************
iptables -A INPUT -p icmp -j ACCEPT
iptables -A INPUT -i lo -j ACCEPT

#************************************************
# syn flad block
#************************************************
iptables -A INPUT -p tcp --syn -m limit --limit 1/s -j ACCEPT
iptables -A INPUT -p icmp --icmp-type echo-request -m limit --limit 1/s -j ACCEPT

#************************************************
# response packet
#************************************************
iptables -A INPUT -m state --state ESTABLISHED,RELATED -j ACCEPT
iptables -A OUTPUT -m state --state ESTABLISHED,RELATED -j ACCEPT

#************************************************
# ssh
#************************************************
iptables -A INPUT -p tcp --dport 22 -j ACCEPT

#************************************************
# HTTP
#************************************************
iptables -A INPUT -p tcp --dport 80 -j ACCEPT

#************************************************
# HTTPS
#************************************************
iptables -A INPUT -p tcp --dport 443 -j ACCEPT

##************************************************
# SMTP
#************************************************
iptables -A INPUT -p tcp --dport 25 -j ACCEPT

#************************************************
# SMTPS
#************************************************
iptables -A INPUT -p tcp --dport 465 -j ACCEPT

#************************************************
# POP
#************************************************
iptables -A INPUT -p tcp --dport 110 -j ACCEPT

#************************************************
# POPS
#************************************************
iptables -A INPUT -p tcp --dport 995 -j ACCEPT

##************************************************
# DNS
#************************************************
iptables -A INPUT -p tcp --dport 53 -j ACCEPT
iptables -A INPUT -p udp --dport 53 -j ACCEPT

##************************************************
# NTP
#************************************************
iptables -A INPUT -p udp --dport 123 -j ACCEPT

#************************************************
# FTP
#************************************************
iptables -A INPUT -p tcp -m multiport --dport 20:21 -j ACCEPT
iptables -A INPUT -p tcp -m multiport --dport 21000:21030 -j ACCEPT

#************************************************
# save and apply
#************************************************
/etc/init.d/iptables save
/etc/rc.d/init.d/iptables restart
